using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Logging;
using NLog.Extensions.Logging;
using Serilog;

namespace ProjectMonorail
{
    internal static class Program
    {
        /// <summary>
        ///  The main entry point for the application.
        /// </summary>
        [STAThread]
        private static void Main()
        {
            ApplicationConfiguration.Initialize();

            ServiceCollection services = new ServiceCollection();
            ConfigureServices(services);
            using ServiceProvider serviceProvider = services.BuildServiceProvider();

            Application.Run(serviceProvider.GetRequiredService<FormMonorailCollection>());
        }

        /// <summary>
        ///   DI
        /// </summary>
        /// <param name="services"></param>
        private static void ConfigureServices(ServiceCollection services)
        {
            services.AddSingleton<FormMonorailCollection>()
            .AddLogging(option => option.AddSerilog(dispose: true));

            Log.Logger = new LoggerConfiguration()
                .MinimumLevel.Debug().WriteTo.File("C:\\\\PIbd-11_Tarasov_V.D._Simple\\ProjectMonorail\\log.txt").CreateLogger();
        }
    }
}