﻿using ProjectMonorail.Scripts.Monorail.Drawnings;

namespace ProjectMonorail.Scripts.Monorail.CollectionGenericObjects
{
    public class DepotSharingService : AbstractCompany
    {
        public DepotSharingService(int pictureWidth, int pictureHeight, ICollectionGenericObjects<DrawingMonorail> collection) : base(pictureWidth, pictureHeight, collection) {}

        private int offsetX = 30;

        protected override void DrawBackgound(Graphics g)
        {
            Pen pen = new Pen(Color.Black, 4);

            int maxCountX = _pictureWidth / _placeSizeWidth;
            int maxCountY = _pictureHeight / _placeSizeHeight;


            for (int i = 0; i < maxCountX; i++)
            {
                for (int j = 0; j < maxCountY; j++)
                {
                    g.DrawLine(pen, i * offsetX + i * _placeSizeWidth, j * _placeSizeHeight, _placeSizeWidth + i * offsetX + i * _placeSizeWidth, j * _placeSizeHeight);
                    g.DrawLine(pen, i * offsetX + i * _placeSizeWidth, j * _placeSizeHeight, i * offsetX + i * _placeSizeWidth, _placeSizeHeight + j * _placeSizeHeight);
                    g.DrawLine(pen, i * offsetX + i * _placeSizeWidth, _placeSizeHeight + j * _placeSizeHeight, _placeSizeWidth + i * offsetX + i * _placeSizeWidth, _placeSizeHeight + j * _placeSizeHeight);
                }
            }
        }

        protected override void SetObjectsPosition()
        {
            int maxCountX = _pictureWidth / _placeSizeWidth;
            int maxCountY = _pictureHeight / _placeSizeHeight;

            int boarderOffsetX = 20;
            int boarderOffsetY = 20;

            int currentIndex = 0;

            for (int j = maxCountY - 1; j >= 0; j--)
            {
                for (int i = 0; i < maxCountX; i++, currentIndex++)
                {
                    if (_collection.Get(currentIndex) == null) continue;

                    _collection.Get(currentIndex).SetPictureSize(_pictureWidth, _pictureHeight);
                    _collection.Get(currentIndex).SetPosition(boarderOffsetX + i * _placeSizeWidth + i * offsetX, boarderOffsetY + j * _placeSizeHeight);
                }
            }
        }
    }
}
