﻿using ProjectMonorail.Scripts.Monorail.Entities;
using System.Diagnostics.CodeAnalysis;

namespace ProjectMonorail.Scripts.Monorail.Drawnings
{
    public class DrawiningMonorailEqutables : IEqualityComparer<DrawingMonorail?>
    {
        public bool Equals(DrawingMonorail? x, DrawingMonorail? y)
        {
            if (x == null || x.EntityMonorail == null) return false;

            if (y == null || y.EntityMonorail == null) return false;

            if (x.GetType().Name != y.GetType().Name) return false;

            if (x.EntityMonorail.Speed != y.EntityMonorail.Speed) return false;

            if (x.EntityMonorail.Weight != y.EntityMonorail.Weight) return false;

            if (x.EntityMonorail.BodyColor != y.EntityMonorail.BodyColor) return false;

            if (x is DrawingModernMonorail xa && y is DrawingModernMonorail ya)
            {
                if (xa.EntityMonorail is EntityModernMonorail left && ya.EntityMonorail is EntityModernMonorail right)
                {
                    if (left.AdditionalColor != right.AdditionalColor) return false;

                    if (left.MonorailTrack != right.MonorailTrack) return false;

                    if (left.Cabin != right.Cabin) return false;
                }
            }
            return true;
        }

        public int GetHashCode([DisallowNull] DrawingMonorail obj)
        {
            return obj.GetHashCode();
        }
    }
}
