﻿namespace ProjectMonorail.Scripts.Monorail.MovementStrategy
{
    /// <summary>
    /// Стратегия перемещения объекта в левый нижний угл экрана
    /// </summary>
    public class MoveToRightDownBorder : AbstractStrategy
    {
        protected override bool IsTargetDestinaion()
        {
            ObjectParameters? objParams = GetObjectParameters;
            if (objParams == null) return false;

            return objParams.RightBorder + GetStep() >= FieldWidth 
                && objParams.DownBorder + GetStep() >= FieldHeight;
        }

        protected override void MoveToTarget()
        {
            ObjectParameters? objParams = GetObjectParameters;
            if (objParams == null) return;

            int diffX = objParams.LeftBorder - FieldWidth;
            if (Math.Abs(diffX) > GetStep())
            {
                MoveRight();
            }

            int diffY = objParams.DownBorder - FieldHeight;
            if (Math.Abs(diffY) > GetStep())
            {
                MoveDown();
            }
        }

    }
}
